#include <GConsoleLib.h>
#include <stdio.h>

//}bvf[^
#define MAXWIDTH 10
#define MAXHEIGHT 7
int g_mapdata[MAXHEIGHT][MAXWIDTH] = {
	//0  1  2  3  4  5  6  7  8  9
	{ 1, 0, 1, 1, 1, 1, 1, 1, 1, 1 }, //0
	{ 1, 0, 0, 1, 2, 0, 0, 1, 3, 1 }, //1
	{ 1, 1, 0, 1, 1, 1, 0, 1, 0, 1 }, //2
	{ 1, 0, 0, 0, 0, 0, 0, 1, 0, 1 }, //3
	{ 1, 0, 1, 1, 1, 1, 1, 1, 0, 1 }, //4
	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 1 }, //5
	{ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 }  //6
};

//}bv̕ỉ摜
char *g_images[] = {
	"C:\\GConsoleǉt@C\\sampleimg\\chap5-1-field.png",
	"C:\\GConsoleǉt@C\\sampleimg\\chap5-1-wall.png",
	"C:\\GConsoleǉt@C\\sampleimg\\chap5-1-goal.png",
	"C:\\GConsoleǉt@C\\sampleimg\\chap5-1-key.png",
	"C:\\GConsoleǉt@C\\sampleimg\\chap5-1-man.png"
};

//l̈ʒu
int g_x = 1, g_y = 0;
int g_keyfrag = 0;	//EtO

//ʍW
int g_scx = 0, g_scy = 0;
#define SCROLLWIDTH 5
#define SCROLLHEIGHT 5
#define CORNERX 165
#define CORNERY 62

//֐vg^Cv錾
void DrawMap();
void RedrawMap(int, int, int, int);
int ScrollCheck(int, int);

int main() {
	gcls();
	gfront();

	DrawMap();	//}bvŜ\

	while (1) {
		glocate(0, 19); gcolor(128, 0, 0);
		gprintf("R}hiAAWASAEDjH@@");
		glocate(32, 19);
		char ch = ggetchar();
		int newx = g_x, newy = g_y;
		switch (ch) {
		case 'W':
		case 'w':
			newy--;
			break;
		case 'S':
		case 's':
			newy++;
			break;
		case 'A':
		case 'a':
			newx--;
			break;
		case 'D':
		case 'd':
			newx++;
			break;
		}
		//ړ`FbN
		if (newx >= 0 && newx < MAXWIDTH && newy >= 0 && newy < MAXHEIGHT) {
			//ǂǂ`FbN
			if (g_mapdata[newy][newx] != 1) {
				//S[ƌ̏
				switch (g_mapdata[newy][newx]) {
				case 3:	//
					g_keyfrag = 1;		//tOI
					g_mapdata[newy][newx] = 0;	//
					break;
				case 2:	//S[
					if (g_keyfrag) goto GAMECLEAR;
					break;
				}
				int oldx = g_x;
				int oldy = g_y;
				g_x = newx;
				g_y = newy;
				//ScrollCheck֐̓XN[̕Kv1A
				//svȂ0Ԃ
				if (ScrollCheck(newx, newy)) {
					DrawMap();	//Sʏ
				} else {
					RedrawMap(oldx, oldy, newx, newy);	//ꕔ
				}
			}
		}
	}
	//Q[I
GAMECLEAR:
	char *ending[] = {
		"N͂ɃS[ɂǂ蒅",
		"{ɖ`͏Î낤ccH",
		"",
		"@@@@@@@@@END?"
	};
	gcls();
	gcolor(0, 0, 0);
	gbox(0, 0, 640, 480);
	gcolor(255, 255, 255);
	for (int i = 0; i < 4; i++) {
		glocate(12, 16 + i);
		gprintf(ending[i]);
	}
	//XN[
	for (int i = 0; i < 90; i++) {
		gprintf("@@@");
	}
}
//}bvĕ`iꕔ̂݁j
void RedrawMap(int oldx, int oldy, int newx, int newy) {
	int mapd = g_mapdata[oldy][oldx];
	gimage(g_images[mapd], 
		(oldx-g_scx) * 62 + CORNERX, (oldy-g_scy) * 62 + CORNERY);
	gimage(g_images[4], 
		(newx-g_scx) * 62 + CORNERX, (newy-g_scy) * 62 + CORNERY);
}

//}bv\
void DrawMap() {
	for (int y = 0; y < SCROLLHEIGHT; y++) {
		for (int x = 0; x < SCROLLWIDTH; x++) {
			if (x+g_scx == g_x && y+g_scy == g_y) {
				//l\
				gimage(g_images[4], 
					(g_x-g_scx) * 62 + CORNERX, (g_y-g_scy) * 62 + CORNERY);
			} else {
				int mapd = g_mapdata[y + g_scy][x + g_scx];
				gimage(g_images[mapd], 
					x * 62 + CORNERX, y * 62 + CORNERY);
			}
		}
	}
}

//XN[Kv`FbN֐
//ɂ͈ړ̍Ww
int ScrollCheck(int newx, int newy) {
	//݂̕\͈͂яoĂ邩`FbN
	//FWg_mapdata͈͓̔ɂ邱Ƃ̓`FbNς
	if (newx < g_scx || newy < g_scy ||
		newx > g_scx + SCROLLWIDTH - 1 ||
		newy > g_scy + SCROLLHEIGHT - 1) 
	{
		g_scx = newx / SCROLLWIDTH * SCROLLWIDTH;
		if (g_scx + SCROLLWIDTH > MAXWIDTH) {
			g_scx = MAXWIDTH - SCROLLWIDTH;
		}
		g_scy = newy / SCROLLHEIGHT * SCROLLHEIGHT;
		if (g_scy + SCROLLHEIGHT > MAXHEIGHT) {
			g_scy = MAXHEIGHT - SCROLLHEIGHT;
		}
		return 1;	//^
	}
	return 0;		//U
}